#!/bin/csh -f
set out_inc = $1"fortran.inc"
set out_c = $1"fortran.c"
set ciproto = $1"ciproto.h"

/bin/rm -f ${out_c}
/bin/rm -f ${out_inc}

cat > cfgen.h << END
#include <utilcitypedef.h>
#include <extrapcitypedef.h>
END

#---- out_c generation
grep ci_typedef ${ciproto} | sed 's/^.*://g' >> cfgen.h
grep '\/\* *fortran *\*\/' $1*.h | grep -v 'ciproto' | sed 's/^.*://g' >> cfgen.h

echo cicf -h cfgen.h  -o cfgen.c -f cfgen.fff $2
cicf -h cfgen.h  -o cfgen.c -f cfgen.fff $2 -I ${ONXSRC}

sed 's/PPOINTER/PVOID/g' cfgen.c > cfgen1.c
/bin/mv cfgen1.c cfgen.c

cat > ${out_c} << END
#ifndef VAXC
#include <cxxfortran.h>
#else
#include <cfortran.h>
#endif
END

cat cfgen.h cfgen.c >> ${out_c}

#---- out_inc generation
#---- enleve les external produits par cicf dans dcfortran.fff
grep -v external cfgen.fff | sed 's/^.*://g' >> cfgen1.fff

#---- build the packagefortran.inc (include file for fortran to be used with C preproc)
cat > ${out_inc} << END
C fortran header file to be "#included" by client fortran codes
#include <pointer.inc>
END

cat cfgen1.fff >> ${out_inc}

/bin/rm -f cfgen.h
/bin/rm -f cfgen.c
/bin/rm -f cfgen.fff
/bin/rm -f cfgen1.fff



