*
*     ... THIS FUNCTION RETURNS THE DEPTH IN THE ATMOSPHERE ...
*     ... BETWEEN THE POINT WITH RADIUS_VECTOR R(3) AND THE ...
*     ... ISS POINT
*     ... DATE: 3.06.2002
*     ... AUTHOR: D.V. NAUMOV
*
      REAL FUNCTION DEPTH_R_ISS(R)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
*     ... EXTERNAL CALLS ...
      REAL HXY
*     ... INPUT VARIABLES ...
      REAL R(3)
*     ... LOCAL VARIABLES ...
      INTEGER i_aux_hbk, ID
      REAL RTOISS(3), PI, HALF_PI, H_R,THETA_R, DEPTH_R, SCALAR_R
      REAL SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS,cos_R_ISS
      REAL DEPTH_INTEGRAL
      SAVE i_aux_hbk
      DATA i_aux_hbk/0/
      LOGICAL HEXIST
*
      PI      = ACOS(-1.)
      HALF_PI = PI/2
      ID = 100*ATMO
*
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      CALL VECTORDOT(3,R,R,SCALAR_R)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
         cos_R_ISS  = SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
         cos_R_ISS  = 0.
      ENDIF
      IF(ABS(cos_R_ISS).LE.1.) THEN
        THETA_R = ACOS(cos_R_ISS)/PI*180
      ELSE
        IF(cos_R_ISS.GT.0) THETA_R = 0.
        IF(cos_R_ISS.LT.0) THETA_R = 180.
      ENDIF
      H_R     = SQRT(SCALAR_R) - R_EARTH
      IF(THETA_R.LE.HALF_PI) THEN
         DEPTH_R = HXY(ID+CURV,THETA_R,H_R)
c        DEPTH_R = DEPTH_INTEGRAL(THETA_R,H_R)
      ELSE
         DEPTH_R = 0.
      ENDIF
*         
      DEPTH_R_ISS  = DEPTH_R 
 1000 CONTINUE
      END
