      SUBROUTINE IMPACT(R,Hstar,H_INT,THETA_INT,H_R,THETA_R)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
      REAL R(3), H, Hstar, H_INT, THETA_INT,H_R, THETA_R, PI, HALF_PI
      REAL THETA0
*
      PI      = ACOS(-1.)
      HALF_PI = PI/2
      THETA0 = THETA
      IF(THETA.GT.PI/2) THETA0 = PI - THETA
*     ... COMPUTE THE INITIAL HEIGHT ...
      H_INT = SQRT(RINT(1)**2+RINT(2)**2+RINT(3)**2)-R_EARTH
*     ... COMPUTE THE INITIAL ANGLE ...
      THETA_INT = ASIN((H+R_EARTH)*SIN(THETA0)/(H_INT + R_EARTH))
*     ... COMPUTE THE CURRENT HEIGHT ...
      H_R = SQRT(R(1)**2+R(2)**2+R(3)**2) - R_EARTH

      IF(THETA.NE.0.) THEN
*     ... COMPUTE THE VERTICAL HEIGHT UNDER THE ISS ...
        H  = RINT(3) - SQRT(RINT(1)**2+RINT(2)**2)/tan(THETA0) - R_EARTH
*     ... COMPUTE THE IMPACT PARAMETER ...
        Hstar = (H + R_EARTH)*SIN(THETA0) - R_EARTH
*     ... COMPUTE THE CURRENT ANGLE ...
        THETA_R = (Hstar+R_EARTH)/(H_R + R_EARTH)
        IF(THETA_R.GE.1.) THEN
          THETA_R = HALF_PI
        ELSE
          THETA_R = ASIN(THETA_R)
        ENDIF
      ELSE
        H = H_INT
        Hstar = - R_EARTH
        THETA_R = THETA
      ENDIF
      IF(THETA.GE.PI/2) THEN
        THETA_R = PI - THETA_R
        THETA_INT = PI - THETA_INT
      ENDIF
c      write(6,*) 'impact:',R,Hstar,H_INT,THETA_INT/PI*180,H_R,
c     +     THETA_R/PI*180,(Hstar+R_EARTH)/(H_R + R_EARTH)
      END
