      SUBROUTINE LOWTRAN_FLUOR_R_ISS(R,WAVEIN,TFINAL)
      IMPLICIT NONE
#include "detector.inc"
#include "lowtran_ntuple.inc"
#include "lowtran.inc"
*     ... EXTERNAL FUNCTIONS ...
      REAL HXY
*     ... INPUT VARIABLES ...
      REAL R(3),WAVEIN
*     ... OUTPUT VARIABLES ...
      REAL TFINAL
*     ... LOCAL VARIABLES ...
      REAL RTOISS(3),cos_R_ISS,SCALAR_ISS_RTOISS,SCALAR_ISS
      REAL PI,ANGL,SCALAR_RTOISS,H,V,V1C,V2C
      INTEGER I,J,ID,lv,ifound
*
      REAL HIJ,H1D,H2D,ANGL1,ANGL2,f1,f2
*     ... SOME CONSTANTS ...
      PI = ACOS(-1.)
*     ... RTOISS = ISS - R
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
         cos_R_ISS  = SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
         cos_R_ISS  = 0.
      ENDIF
      IF(ABS(cos_R_ISS).LE.1.) THEN
        ANGL = ACOS(cos_R_ISS)/PI*180
      ELSE
        IF(cos_R_ISS.GT.0) ANGL = 0.
        IF(cos_R_ISS.LT.0) ANGL = 180.
      ENDIF
      H    = SQRT(R(1)**2+R(2)**2+R(3)**2) - R_EARTH
*
      IF(WAVEIN.NE.0.) V = 10**(7)/WAVEIN ! CONVERSION TO THE FREQUENCY ADOPTED IN LOWTRAN
*
      lv = 0
      ifound = 0
      TFINAL = 0.
      DO V1C = EV1, EV2-EDV, EDV
        lv = lv + 1
        ID = 50000 + lv
        V2C = V1C +  EDV
        IF(V1C.LE.V.AND.V.LT.V2C) THEN
          ifound = ifound + 1
* ... doing a linear interpolation ...
          CALL HXYIJ (ID,H,ANGL,I,J)
          CALL HIJXY (ID,I,J,H1D,ANGL1)
          CALL HIJXY (ID,I+1,J,H2D,ANGL1)
          f1 = HIJ (ID,I,J) 
          f2 = HIJ (ID,I+1,J)
          TFINAL  = f1 + (H-H1D)*(f2-f1)/(H2D-H1D)
*          TFINAL = HXY(ID,H,ANGL)
          IF(TFINAL.GT.1.) WRITE(6,*) 'LOWTRAN TRANSMISSION IS > 1'
        ENDIF
      ENDDO
      IF(ifound.EQ.0) WRITE(6,*) WAVEIN,
     &     ' IS NOT FOUND IN LOWTRAN_FLUOR_R_ISS WAVELENGTH RANGE', 
     &     10**(7)/EV1,10**(7)/EV2
*
      END
