      SUBROUTINE LOWTRAN_R_ISS(R,WAVE1,WAVE2,TFINAL)
      IMPLICIT NONE
#include "detector.inc"
#include "lowtran_ntuple.inc"
#include "lowtran.inc"
*     ... EXTERNAL FUNCTIONS ...
      REAL HXY
*     ... INPUT VARIABLES ...
      REAL R(3),WAVE1,WAVE2
*     ... OUTPUT VARIABLES ...
      REAL TFINAL
*     ... LOCAL VARIABLES ...
      REAL RTOISS(3),cos_R_ISS,SCALAR_ISS_RTOISS,SCALAR_ISS
      REAL PI,ANGL,SCALAR_RTOISS,H,V,V1C,V2C,V1D,V2D,SUM
      INTEGER I,ID,lv,NV,ifound(200),isum
      
*     ... SOME CONSTANTS ...
      PI = ACOS(-1.)
*     ... RTOISS = ISS - R
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
         cos_R_ISS  = SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
         cos_R_ISS  = 0.
      ENDIF
      IF(ABS(cos_R_ISS).LE.1.) THEN
        ANGL = ACOS(cos_R_ISS)/PI*180
      ELSE
        IF(cos_R_ISS.GT.0) ANGL = 0.
        IF(cos_R_ISS.LT.0) ANGL = 180.
      ENDIF
      H    = SQRT(R(1)**2+R(2)**2+R(3)**2) - R_EARTH
*     ... INTEGRATE OVER CHERENKOV SPECTRUM ...
      NV = 100
      IF(WAVE1.NE.0.) V2D = 10**(7)/WAVE1
      IF(WAVE2.NE.0.) V1D = 10**(7)/WAVE2
      DV = (V2D-V1D)/NV
      SUM = 0.
*
      DO i = 1, 200
        ifound(i) = 0
      ENDDO
*
      DO I = 1, NV
        V = V1D + (I-1)*DV + DV/2
        lv = 0
        DO V1C = EV1, EV2-EDV, EDV
          lv = lv + 1
          ID = 50000 + lv
          V2C = V1C +  EDV
          IF(V1C.LE.V.AND.V.LT.V2C) THEN
            ifound(i) = 1
            SUM = SUM + HXY(ID,H,ANGL)
          ENDIF
        ENDDO
      ENDDO
      TFINAL = SUM/NV
      isum = 0
      DO i = 1, NV
        isum = isum + ifound(i) 
      ENDDO
*
      END
