*
*     ... THIS FUNCTION RETURNS THE MIE TRANSITION FACTOR   ...
*     ... IN THE ATMOSPHERE BETWEEN THE POINTS WITH         ...
*     ... RADIUS_VECTORS R1(3) AND R2(3)                    ...
*     ... DATE: 09.06.2002
*     ... AUTHOR: D.V. NAUMOV
*
      REAL FUNCTION MIE_R_RINT(R1,R2)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
      INTEGER i_aux_hbk, ID
      REAL R1(3),R2(3),PI,HALF_PI,Hstar,H_INT,THETA_INT
      REAL H_R1,H_R2,THETA_R1,THETA_R2
      REAL MIE_R1,MIE_R2,HXY
      SAVE i_aux_hbk
      DATA i_aux_hbk/0/
      LOGICAL HEXIST
*
      PI      = ACOS(-1.)
      HALF_PI = PI/2
      ID = 10000
c      IF(IMIE.EQ.0) THEN
c         IF(i_aux_hbk.EQ.0) THEN
c            IF(.NOT.HEXIST(ID)) CALL HRGET (ID,'aux.hbk',' ')
c            i_aux_hbk = 1
c         ENDIF
*     
         CALL IMPACT(R1,Hstar,H_INT,THETA_INT,H_R1,THETA_R1)
         CALL IMPACT(R2,Hstar,H_INT,THETA_INT,H_R2,THETA_R2)
*     ... COMPUTE MIE FACTORS BETWEEN R1 AND INFINITY ...
         IF(THETA_R1.LE.HALF_PI) THEN
            MIE_R1 = HXY(ID,THETA_R1,H_R1)
         ELSE
            THETA_R1 = PI - THETA_R1
            MIE_R1 = 2*HXY(ID,Hstar,HALF_PI) - HXY(ID,THETA_R1,H_R1)
         ENDIF
*     ... COMPUTE MIE FACTORS BETWEEN R2 AND INFINITY ...
         IF(THETA_R2.LE.HALF_PI) THEN
            MIE_R2 = HXY(ID,THETA_R2,H_R2)
         ELSE
            THETA_R2 = PI - THETA_R2
            MIE_R2 = 2*HXY(ID,Hstar,HALF_PI) - HXY(ID,THETA_R2,H_R2)
         ENDIF
*     ... COMPUTE MIE FACTOR BETWEEN R1 AND R2 ...
         MIE_R_RINT = EXP(-ABS(MIE_R1 - MIE_R2))
         
c      ENDIF
 1000 CONTINUE
      END
