*     ...
      SUBROUTINE DO_CHERENKOV(Lc,Lmax,L_step,S,Ne,NchISS,
     +     NchISSTRAN,TRS,TMS,time_ch1,time_ch2)
      IMPLICIT NONE
#include "event.inc"
#include "detector.inc"
#include "refractive.inc"
*     ... EXTERNAL FUNCTIONS ...
      REAL DEPTH,DEPTH_R_ISS,ATM,REFRACTIVE_INDEX, CHERENKOV_THRESHOLD
*     ... INPUT VARIABLES ...
      REAL Lc,Lmax,L_step,S,Ne
*     ... OUTPUT VARIABLES ...
      REAL NchISS,NchISSTRAN,TRS,TMS,time_ch1,time_ch2,wave_ch
*     ... LOCAL VARIABLES ...
      REAL R(3),RG(3),RTOISS(3),Nch
      REAL PI,factor,SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS
      REAL cos_G_ISS,GROUND_TO_ISS_FACTOR,TR_G,TM_G,TFINAL_R_RG
      REAL TR_G_ISS,TM_G_ISS,TFINAL_G_ISS,time_to_ground,full_time
      REAL ET,DELTA,WAVE_STEP,dw
      INTEGER I, wave_init,N,IERR
      SAVE wave_init
      DATA wave_init/0/
*
      IF(CH_FLAG.NE.1) RETURN
*     ... SOME CONSTANTS ...
      PI = ACOS(-1.)
*     ...   4*pi*alpha*DELTA0/RHO(0)*10^9 ...
c      factor = 4*PI*DELTA0*1.e13/137.036/ATM(0.) 
      factor = 4*PI/137.036*1.e9
*     ... CURRENT AND THE GROUND POINTS ...
      R(1)  = RINT(1) - (Lc+L_step/2)*SIN(THETA)*COS(PHI)
      R(2)  = RINT(2) - (Lc+L_step/2)*SIN(THETA)*SIN(PHI)
      R(3)  = RINT(3) - (Lc+L_step/2)*COS(THETA)
      RG(1) = RINT(1) - Lmax*SIN(THETA)*COS(PHI)
      RG(2) = RINT(2) - Lmax*SIN(THETA)*SIN(PHI)
      RG(3) = RINT(3) - Lmax*COS(THETA)      
*     ... RTOISS = ISS - RG
      CALL VECTORLIB(3,'-',ISS,RG,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
         cos_G_ISS  = SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
         cos_G_ISS  = 0.
      ENDIF
*     ... HERE ONE ASSUMES THAT THE REFLECTED LIGHT FOLLOWS  ...
*     ... cos_G_ISS/PI ANGULAR DISTRIBUTION                  ...
*     ... WHICH IS DIFFERENT FROM THE "NAIVE" 1./2/PI        ...
      GROUND_TO_ISS_FACTOR = SDIA**2/4*cos_G_ISS**4/
     +     (ISS(3)-R_EARTH)**2/1.e6*ALBEDO
      time_ch1 =  10./3*(Lmax+SQRT(SCALAR_RTOISS))
      time_ch2 =  time_ch1 + (DEPTH(RG)-DEPTH(R))*DELTA0/ATM(0.) + 
     +     DEPTH_R_ISS(RG)*DELTA0/ATM(0.)   
*     ... NOW COMPUTE THE NUMBER OF CHERENKOV PHOTONS ...

      DELTA         = REFRACTIVE_INDEX(R(1),R(2),R(3))
      ET            = 0.511/SQRT(DELTA) ! threshold energy in MeV
      Nch           = factor*Ne*CHERENKOV_THRESHOLD(S,ET)*L_step*1.e3
      Nch           = Nch*DELTA
      NchISS        = Nch*GROUND_TO_ISS_FACTOR
      NchISSTRAN    = NchISS

      CALL TRANSITION_R_RINT(R,RG,WAVE(1),WAVE(2),
     +     TR_G,TM_G,TFINAL_R_RG)
      CALL TRANSITION_R_ISS(RG,WAVE(1),WAVE(2),
     +     TR_G_ISS,TM_G_ISS,TFINAL_G_ISS)
      dw            = (1/WAVE(1)-1/WAVE(2))
      NchISS        = NchISS*dw
      IF(OUTC.EQ.'RAND') THEN
        CALL RNPSSN(NchISS,N,IERR)
        IF(IERR.EQ.0) NchISS = 1.*N
      ENDIF
      NchISSTRAN    = NchISSTRAN*dw*TFINAL_R_RG*TFINAL_G_ISS
      TRS           = TR_G*TR_G_ISS
      TMS           = TM_G*TM_G_ISS
*
      END

