      REAL FUNCTION FLUOR_ENERGY(S,KEY)
      IMPLICIT NONE
#include "shower.inc"
      REAL AGE,A,B,S,RELTOL,ABSTOL,ERR,RES,RES_NORM
      COMMON/FLUOR_INT/AGE
      INTEGER ID,NSEG,KEY
      EXTERNAL FLUOR_ENERGY_INT_KAKIMOTO_1,FLUOR_ENERGY_INT_KAKIMOTO_2
      EXTERNAL ENERGY_SPECTRUM_HILLAS_NORM
      AGE = S
      A = 0.
      B = 1.
      ID = 100000*DIST
      NSEG = 1
      RELTOL = 1.e-8
      ABSTOL = 0.
*
      CALL RADAPT(ENERGY_SPECTRUM_HILLAS_NORM,A,B,NSEG,RELTOL,
     +     ABSTOL,RES_NORM,ERR)
      IF(KEY.EQ.1) THEN
        CALL RADAPT(FLUOR_ENERGY_INT_KAKIMOTO_1,A,B,NSEG,RELTOL,
     +       ABSTOL,RES,ERR)
      ELSEIF(KEY.EQ.2) THEN
        CALL RADAPT(FLUOR_ENERGY_INT_KAKIMOTO_2,A,B,NSEG,RELTOL,
     +       ABSTOL,RES,ERR)
      ENDIF
*      
      FLUOR_ENERGY =  RES/RES_NORM

      END
*
      REAL FUNCTION FLUOR_ENERGY_INT_KAKIMOTO_1(y)
      IMPLICIT NONE
#include "shower.inc"
      REAL y,S,ET,ENERGY_SPECTRUM_HILLAS,ESTOPING_POWER,f
      COMMON/FLUOR_INT/S
      f = ENERGY_SPECTRUM_HILLAS(S,1.4/y)/y**2
      f = f*ESTOPING_POWER(1.4/y)/ESTOPING_POWER(1.4)
      FLUOR_ENERGY_INT_KAKIMOTO_1 = 1.4*f
      END
*
      REAL FUNCTION FLUOR_ENERGY_INT_KAKIMOTO_2(y)
      IMPLICIT NONE
#include "shower.inc"
      REAL y,S,ET,ENERGY_SPECTRUM_HILLAS,f
      COMMON/FLUOR_INT/S
      f = ENERGY_SPECTRUM_HILLAS(S,1.4*y)
      FLUOR_ENERGY_INT_KAKIMOTO_2 = 1.4*f
      END
*
      REAL FUNCTION ENERGY_SPECTRUM_HILLAS_NORM(y)
      IMPLICIT NONE
#include "shower.inc"
      REAL y,S,ET,ENERGY_SPECTRUM_HILLAS,A
      COMMON/FLUOR_INT/S
*     ... A is an arbitrary number (not zero)  ...
*     ... The integral should not depend on it ...      
      A = 1.
      ENERGY_SPECTRUM_HILLAS_NORM = 
     +     ENERGY_SPECTRUM_HILLAS(S,A/y)/y**2 + 
     +     ENERGY_SPECTRUM_HILLAS(S,A*y)
      ENERGY_SPECTRUM_HILLAS_NORM = 
     +     A*ENERGY_SPECTRUM_HILLAS_NORM
      END
