      SUBROUTINE BOOK_HISTOS(KEYWORD)
#include "detector.inc"      
#include "book_histos.inc"
#include "shower.inc"

      INTEGER i_depth,i_spectrum,i_flu
      SAVE i_depth,i_spectrum,i_mie,i_flu
      DATA i_depth/0/,i_spectrum/0/,i_mie/0/,i_flu/0/
      CHARACTER*4 KEYWORD
      REAL EPS
*
      EPS = 1.e-3
      Hmax = 1.e2
      Thmax = acos(-1.)/2
      Nth = 1000
      Nh = 500 
*
      Emin = 1.e0               ! MeV
      Emax = 1.e4               ! MeV
      Ne = 10000
      Ns = 20
      Smin = 0.1
      Smax = 2.0
*     ... DEPTH'S HISTOS ...
      IF(DEPT.EQ.1.AND.i_depth.EQ.0) THEN
*
         DO i = 1, 2
            ID = i*100
            CALL HBPROF(ID,'ATM',100,0.,100.,0.,1.,' ')
            CALL HBOOK2(ID+1,'DEPTH SPH',Nth,0.,Thmax+EPS,Nh,0.,Hmax,0.)
            CALL HBOOK2(ID+2,'DEPTH PLA',Nth,0.,Thmax+EPS,Nh,0.,Hmax,0.)
         ENDDO
         i_depth = 1
      ENDIF
*     ... ENERGY SPECTRUM'S HISTOS ...
      IF(SPEC.EQ.1.AND.i_spectrum.EQ.0) THEN
         DO i = 1, 1
            ID = 1000*i
            CALL HBOOK2(ID,'FRACTION',Ns,Smin,Smax,Ne,Emin,Emax,0.)
            CALL HBOOK2(ID+1,'DISTR ',Ns,Smin,Smax,Ne,Emin,Emax,0.)
            CALL HBOOK2(ID+2,'FRACINT ',Ns,Smin,Smax,Ne,Emin,Emax,0.)
            CALL HBOOK2(ID+3,'CH_THR  ',Ns,Smin,Smax,Ne,Emin,Emax,0.) 
         ENDDO
            i_spectrum = 1
      ENDIF
*     ... MIE HISTO ...
      IF(IMIE.EQ.1.AND.i_mie.EQ.0) THEN
         ID = 10000
         CALL HBOOK2(ID,'MIE',Nth,0.,Thmax+EPS,Nh,0.,Hmax,0.)
         i_mie = 1
      ENDIF
*     ... FLUORESCENT HISTOS ...
      IF(i_flu.EQ.0) THEN
         ID = 100000
         CALL HBPROF(ID,'WEIGHT1',100,0.,2.,0.,10.,' ')
         CALL HBPROF(ID+1,'WEIGHT2',100,0.,2.,0.,10.,' ')
         CALL HBOOK2(ID+2,'FLUOR FINAL',Ns,Smin,Smax,Nh,0.,Hmax,0.)
         i_flu = 1
       ENDIF
      END
