      SUBROUTINE FLUOR_INIT
#include "event.inc"
#include "shower.inc"
#include "detector.inc"
      CHARACTER*22 CHTAG(1)/'FLUORESCENT YIELDS    '/

      IF(IFLU.NE.1) RETURN
      Ns   = 200
      Smin = 1.e-5
      Smax = 2.0
      step_s = (Smax-Smin)/(Ns-1)
      Nint = Ns
      i_portion = Nint/10
*
      CALL BOOK_HISTOS('DUMP')
*
      WRITE(6,*) ' '
      WRITE(6,98)
      WRITE(6,99)
*
      l = 0 
      ID = 100000
      DO j = 1, Ns
        s = Smin + (j-1)*step_s
        l = l + 1
        CALL HFILL(ID,s,FLUOR_ENERGY(s,1),1.)
        CALL HFILL(ID+1,s,FLUOR_ENERGY(s,2),1.)
        ntmp = l/i_portion
        ntmp = l - ntmp*i_portion
        IF(ntmp.EQ.0) WRITE(6,100)
      ENDDO
      WRITE(6,101)
      WRITE(6,*) ' '
*
      WRITE(6,99)
      Nh   = 500
      Hmax = 1.e2
      step_h = Hmax/Nh
      Ns = 20
      Smin = 0.1
      Smax = 2.0
      step_s = (Smax-Smin)/(Ns-1)
      i_portion = Nh*(Ns-1)/10
      l = 0 
*
      DO j = 1, Ns-1
        s = Smin + (j-1)*step_s + step_s/2
        DO i = 0, Nh-1
          h = i*step_h + step_h/2
          l = l + 1
          CALL HFILL(ID+2,s,h,FLUOR_YIELD(s,h))
          write(6,*) s,h,FLUOR_YIELD(s,h)
         ntmp = l/i_portion
          ntmp = l - ntmp*i_portion
          IF(ntmp.EQ.0) WRITE(6,100)
        ENDDO
      ENDDO
      WRITE(6,101)
      WRITE(6,*) ' '
*
      CALL RANDOM_OUTPUT
 98   FORMAT(1x,'COMPUTING THE FLUORESCENT YIELDS INTEGRALS: ')
 99   FORMAT($,32x,' ')
 100  FORMAT($,1x,'.')
 101  FORMAT($,1x,'[done]')
      END
      
