      SUBROUTINE INIT
#include "detector.inc"
#include "event.inc"
#include "shower.inc"
#include "cwntvars.inc"
*
      INTEGER*4 KEYSIZ
      PARAMETER (KEYSIZ=8)
      COMMON/CFREAD/SPACE(1000)
      CALL FFINIT(1000)
*
      CALL FFSET('LINP',10)
      CALL FFSET('LOUT',11)
      CALL FFSET('SIZE',KEYSIZ)
*     ... DEFINE INPUT/OUTPUT FILES
      OPEN (UNIT=10,FILE='global.datacard',STATUS='OLD')
      OPEN (UNIT=11,FILE='ffkey.check',STATUS='UNKNOWN')
*     ... DETECTOR AND ATMOSPHERE KEYS ...
      CALL FFKEY('ERAD',R_EARTH,1,'REAL')
      CALL FFKEY('ISSF',ISS,3,'REAL')
      CALL FFKEY('FOV',FOV,1,'REAL')
      CALL FFKEY('ARES',ANG_RES,1,'REAL')
      CALL FFKEY('NPMT',N_PMT,1,'INTEGER')
      CALL FFKEY('SDIA',SDIA,1,'REAL')
      CALL FFKEY('WAVE',WAVE,2,'REAL')
      CALL FFKEY('WINT',WAVEINT,1,'INTEGER')
      CALL FFKEY('ATMO',ATMO,1,'INTEGER')
      CALL FFKEY('TEMP',TEMP,1,'REAL')
      CALL FFKEY('DEPT',DEPT,1,'INTEGER')
      CALL FFKEY('IMIE',IMIE,1,'INTEGER')
      CALL FFKEY('IFLU',IFLU,1,'INTEGER')
      CALL FFKEY('DIST',DIST,1,'INTEGER')
      CALL FFKEY('SPEC',SPEC,1,'INTEGER')
      CALL FFKEY('LWTR',LWTR,1,'INTEGER')
      CALL FFKEY('TRAN',TRAN,1,'INTEGER')
      CALL FFKEY('ALBE',ALBEDO,1,'REAL')
      CALL FFKEY('GTU',GTU,1,'REAL')
      CALL FFKEY('QEFF',QEFF,1,'REAL')
      CALL FFKEY('CURV',CURV,1,'INTEGER')
      CALL FFKEY('THRE',THRESHOLD,1,'REAL')
*     ... EVENT KEYS ...
      CALL FFKEY('RUN',RUN,1,'INTEGER')
      CALL FFKEY('NEVT',NEVT,1,'INTEGER')
      CALL FFKEY('DOCH',CH_FLAG,1,'INTEGER')
      CALL FFKEY('DOFL',FL_FLAG,1,'INTEGER')
      CALL FFKEY('RINT',RINT,3,'REAL')
      CALL FFKEY('THET',THETAR,2,'REAL')
      CALL FFKEY('PHI', PHIR,2,'REAL')
      CALL FFKEY('EINT',EINTR,2,'REAL')
      CALL FFKEY('TYPE',TYPER,1,'INTEGER')
      CALL FFKEY('ZNUC',ZNUC,1,'INTEGER')
      CALL FFKEY('INTE',INTTYPE,1,'INTEGER')
      CALL FFKEY('QCDC',QCDCORR,1,'MIXED')
      CALL FFKEY('SHOW',SHOW,1,'INTEGER')
      CALL FFKEY('NTUP',NTUP,1,'MIXED')
      CALL FFKEY('POWE',POWER,1,'REAL')
      CALL FFKEY('OUTF',OUTF,1,'MIXED')
      CALL FFKEY('OUTC',OUTC,1,'MIXED')
      CALL FFKEY('ESAF',ESAF,1,'INTEGER')
*
      CALL FFGO
      CLOSE (10)
      CLOSE (11)
*
      WRITE(6,1) 'global.datacard'
      WRITE(6,2) 'ffkey.check'
 1    FORMAT(1x,'=====>',1x,'INITIALIZATION WORDS ARE READ FROM',1x,
     +     A)
 2    FORMAT(1x,'=====>',1x,'CHECK',1x,A,1x,'FILE')
      END
