      SUBROUTINE LOWTRAN_INIT
      IMPLICIT NONE
#include "lowtran.inc"
#include "lowtran_ntuple.inc"
#include "detector.inc"
*
      INTEGER*4 KEYSIZ
      REAL SPACE
      PARAMETER (KEYSIZ=8)
      COMMON/CFREAD/SPACE(1000)
*
      REAL RELHUM,HSTOR,VH,TX,W,ZM,PM,TM,RFNDX,DENSTY,CLDAMT,RRAMT,
     &     EQLWC,HAZEC
      REAL V,V1C,V2C,H1C,H2C,H_step,ANGL,H,theta_step
      INTEGER ICH,I,NH,NV,NA,i_portion,Nint,ntmp,k,iH,lv,ID
      COMMON RELHUM(34),HSTOR(34),ICH(4),VH(17),TX(63),W(63) 
      COMMON/MODEL/   ZM(34),PM(34),TM(34),RFNDX(34),DENSTY(63,34),
     1     CLDAMT(34),RRAMT(34),EQLWC(34),HAZEC(34)

      CALL FFSET('LINP',10)
      CALL FFSET('LOUT',11)
*     ... DEFINE INPUT/OUTPUT FILES
      OPEN (UNIT=10,FILE='lowtran.datacard',STATUS='OLD')
      OPEN (UNIT=11,FILE='lowtran.ffkey.check',STATUS='UNKNOWN')
*    ... CARD1 ...
      CALL FFKEY('MODE',EMODEL,1,'INTEGER')
      CALL FFKEY('ITYP',EITYPE,1,'INTEGER')
      CALL FFKEY('IEMS',EIEMSCT,1,'INTEGER')
      CALL FFKEY('IMUL',EIMULT,1,'INTEGER')
      CALL FFKEY('M1',EM1,1,'INTEGER')
      CALL FFKEY('M2',EM2,1,'INTEGER')
      CALL FFKEY('M3',EM3,1,'INTEGER')
      CALL FFKEY('M4',EM4,1,'INTEGER')
      CALL FFKEY('M5',EM5,1,'INTEGER')
      CALL FFKEY('M6',EM6,1,'INTEGER')
      CALL FFKEY('MDEF',EMDEF,1,'INTEGER')
      CALL FFKEY('IM',EIM,1,'INTEGER')
      CALL FFKEY('NOPR',ENOPRT,1,'INTEGER')
      CALL FFKEY('TBOU',ETBOUND,1,'REAL')
*     ... CARD2 ...
      CALL FFKEY('IHAZ',EIHAZE,1,'INTEGER')
      CALL FFKEY('ISEA',EISEASN,1,'INTEGER')
      CALL FFKEY('IVUL',EIVULCN,1,'INTEGER')
      CALL FFKEY('ICST',EICSTL,1,'INTEGER')
      CALL FFKEY('ICLD',EICLD,1,'INTEGER')
      CALL FFKEY('IVSA',EIVSA,1,'INTEGER')
      CALL FFKEY('VIS',EVIS,1,'REAL')
      CALL FFKEY('WSS',EWSS,1,'REAL')
      CALL FFKEY('WHH',EWHH,1,'REAL')
      CALL FFKEY('RAIN',ERAINRT,1,'REAL')
      CALL FFKEY('GNDA',EGNDALT,1,'REAL')
*     ... CARD3 ...
      CALL FFKEY('H1',EH1,1,'REAL')
      CALL FFKEY('H2',EH2,1,'REAL')
      CALL FFKEY('ANGL',EANGLE,1,'REAL')
      CALL FFKEY('RANG',ERANGE,1,'REAL')
      CALL FFKEY('BETA',EBETA,1,'REAL')
      CALL FFKEY('R0',ERE,1,'REAL')
      CALL FFKEY('LEN',ELEN,1,'INTEGER')
*     ... CARD4 ...
      CALL FFKEY('V1',EV1,1,'REAL')
      CALL FFKEY('V2',EV2,1,'REAL')
      CALL FFKEY('DV',EDV,1,'REAL')
*     ... CARD5 ...
      CALL FFKEY('IRPT',EIRPT,1,'INTEGER')
      CALL FFGO
      CLOSE (10)
      CLOSE (11)
*
      SALB = ALBEDO
      IF(LWTR.EQ.0) GOTO 1000
      WRITE(6,1) 'lowtran.datacard'
      WRITE(6,2) 'lowtran.ffkey.check'
 1    FORMAT(1x,'=====>',1x,'LOWTRAN INITIALIZATION WORDS ARE READ FROM'
     +     ,1x,A)
 2    FORMAT(1x,'=====>',1x,'CHECK',1x,A,1x,'FILE')
*
      CALL BOOK_LOWTRAN_NTUPLE
      CALL LOWTRAN_RESET
*
      H_step = 1.e-3            ! km
      theta_step = 1.e-2        ! deg.
      H1C = H1
      H2C = H2
      V1C = EV1
      V2C = EV2
      NH  = INT((H2C-H1C)/H_step)
      NV  = INT((V2C-V1C)/EDV)
      NA  = INT(90/theta_step)
      k = 0
*
      DO I = 1, NV
        ID = 50000 + i
        CALL HBOOK2(ID,'Transmission',NH,H1,H2,NA,0.,90.,0.)
        WRITE(6,*) '**** Histogram ID = ', ID, ' is booked ****'
      ENDDO

      WRITE(6,*) ' '
      WRITE(6,98)
      WRITE(6,99) 'HISTOGRAMMS'
      Nint      = NV*NA*NH
      i_portion = Nint/10
*     ... SAVE HISTOGRAMMS ...
      lv = 1
      DO V = V1C, V2C-EDV, EDV
        ID = 50000 + lv
        lv = lv + 1
        DO H = H1C, H2C, H_step 
          DO ANGL = 0., 90., theta_step
            k = k + 1      
            EV1 = V
            EV2 = EV1 + EDV
            EH1 = H
            EANGLE = ANGL
            CALL LOWTRAN_RESET
            CALL LWTRN7
            CALL HFILL(ID,H1,ANGL,TX(9))
            ntmp = k/i_portion
            ntmp = k - ntmp*i_portion
            IF(ntmp.EQ.0) WRITE(6,100)
          ENDDO
        ENDDO
       CALL HROUT(ID,Icycle,' ')
       CALL HDELET(ID)
      ENDDO
      WRITE(6,101)
      WRITE(6,*) ' '
*     ... SAVE NTUPLE ...

      WRITE(6,99) 'NTUPLE     '
      NH  = 15
      Nint      = NV*NH*NA
      i_portion = Nint/10
      k = 0
      H_step = (H2C-H1C)/(2**NH-1)
      H1 = - H_step
      DO iH = 1, NH
        H1C = H1 + H_step
        H_step = 2*H_step
        EVENT(2) = H1C
        DO V = V1C, V2C-EDV, EDV
          EVENT(1) = 10**(7)/V
          DO ANGL = 0., 90., theta_step
            k = k + 1
            EVENT(3) = ANGL
            EV1 = V
            EV2 = EV1 + EDV
            EH1 = H1C
            EANGLE = ANGL
            CALL LOWTRAN_RESET
            CALL LWTRN7
            EVENT(4) = TX(9)
            CALL HFN(10,Event)
            ntmp = k/i_portion
            ntmp = k - ntmp*i_portion
            IF(ntmp.EQ.0) WRITE(6,100)
          ENDDO
        ENDDO
      ENDDO
*
      WRITE(6,101)
      WRITE(6,*) ' '
*
      CLOSE(66)
      CLOSE(7)
      CLOSE(8)
      CALL HROUT(10,Icycle,' ')
      CALL HREND('LOWTRAN')
 98   FORMAT(1x,'COMPUTING THE LOWTRAN TABLE: ')
 99   FORMAT($,1x,'SAVE ',A,1x,'(breath deeply)')
 100  FORMAT($,1x,'.')
 101  FORMAT($,1x,'[done]')
 1000 RETURN
      END
