      SUBROUTINE DEVELOP_SHOWER(Lmax,KEY_TRIG)
      IMPLICIT NONE
#include "event.inc"
#include "shower.inc"
#include "detector.inc"
#include "cwntvars.inc"
#include "constants.inc"

*     ... EXTERNAL FUNCTIONS ...
      REAL DEPTH_R_RINT, DEPTH, ATM,FLUOR_YIELD
*     ... INPUT VARIABLES    ...
      REAL Lmax
*     ... OUTPUT VARIABLES    ...
      LOGICAL KEY_TRIG
*     ... LOCAL VARIABLES    ...
      REAL L_step, L, R(3), RG(3), Ne1, s, d, t, time_obs_ch,L_GTU
      INTEGER JMax,J, I, mx_fl_int, my_fl_int,mx_ch_int, my_ch_int
      INTEGER in_fov,newGTU,iflmax,ifltmax,ichmax,ichtmax
      REAL H_R_int,L_int,d_int,S_int,Ne_int,time_int,L1,t_max
      REAL TMS_int,NchISS_int,NchISSTRAN_int,TRS_int,TR_int,TM_int
      REAL wave_ch_int,wave_fl_int,theta_xfl_int,theta_yfl_int
      REAL RTOISS(3),SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS
      REAL cos_R_ISS,Lmin,D1,D2,D3,SCALAR11,SCALAR12,dir_unit(3)
*     ... EXCHANGE WITH DO_CHERENKOV ...
      REAL NchISS,NchISSTRAN
      REAL TRG,TMG,TRS,TMS
      REAL TR_G,TM_G,TR_G_ISS,TM_G_ISS,time_ch1d,time_ch2d,time_ch1_int,
     +     time_ch2_int,wave_ch1,THETA_XCH,THETA_YCH
*     ... EXCHANGE WITH DO_FLUORECENCE ...
      REAL Nfl1,NflTRAN,TR,TM,time_fl1d,time_fl2d,Nfl_int,NflTRAN_int,
     +     time_fl1_int,time_fl2_int,wave_fl1,THETA_XFL,THETA_YFL
      INTEGER mx_fl,my_fl,mx_ch,my_ch,ifps,avoid_cycling
*     ... EXCHANGE WITH IMPACT ...
      REAL Hstar,H_INT,THETA_INT,H_R,THETA_R
      REAL HXY
*
      nemaxim = 0.
      hmaxim  = 0.
      xmaxim  = 0.
      yiemax  = 0.
      avoid_cycling = 0
      in_fov = 0
      KEY_TRIG = .FALSE.
      L_GTU    = 3.e-1*GTU      ! L_GTU is in km - length corresponding to 
                                ! one GTU
      Jmax = 10
      dir_unit(1) = SIN(THETA)*COS(PHI)
      dir_unit(2) = SIN(THETA)*SIN(PHI)
      dir_unit(3) = COS(THETA)
      CALL VECTORLIB(3,'-',ISS,RINT,RTOISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR11)
      CALL VECTORDOT(3,RTOISS,dir_unit,SCALAR12)
      SCALAR11 = SQRT(SCALAR11)
*      L_GTU = L_GTU/2*(L_GTU+2*SCALAR11)/(L_GTU+SCALAR11+SCALAR12)
      L_GTU = L_GTU/(1.+SCALAR12/SCALAR11)
      L_step = L_GTU/Jmax
*
      CALL RESET_EVENT
      CALL TRANSFORM_COORDINATES('BACK')
      Xint = RINT(1) 
      Yint = RINT(2)
      Zint = RINT(3)
      Energy = LOG10(EINT)
      Thet  = Theta
      Ph    = Phi
      TYPE  = TYPER
      EW  = EINTW
      ACC = ACCEPTANCE_TYPE
      XPRIM = X1
      CALL TRANSFORM_COORDINATES('FORWARD')
      CALL DEFINE_PIXEL(RG,mx_ch,my_ch,THETA_XCH,THETA_YCH)
*
      Lmin = 0.
      IF(ACC.NE.1.) THEN
        D3 = RINT(1)**2+RINT(2)**2-(ISS(3)-RINT(3))**2*TAN(FOV)**2
        IF(D3.LT.0.) THEN
          Lmin = 0. ! already inside FOV
        ELSE
          Lmin = SQRT((R_EARTH-RINT(3))**2+SQRT(D3))
        ENDIF
      ENDIF
      I = 0
      avoid_cycling = 0
      L1 = Lmin - L_GTU
 1    L1 = L1 + L_GTU
      avoid_cycling = avoid_cycling + 1
      IF(avoid_cycling.GT.10000) GOTO 300
      IF(L1.GT.Lmax) GOTO 200
      R(1) = RINT(1) - (L1+L_GTU)*SIN(THETA)*COS(PHI)
      R(2) = RINT(2) - (L1+L_GTU)*SIN(THETA)*SIN(PHI)
      R(3) = RINT(3) - (L1+L_GTU)*COS(THETA)
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR11)
      CALL VECTORDOT(3,RTOISS,dir_unit,SCALAR12)
      SCALAR11 = SQRT(SCALAR11)
      L_GTU    = 3.e-1*GTU 
*      L_GTU = L_GTU/2*(L_GTU+2*SCALAR11)/(L_GTU+SCALAR11+SCALAR12)
      L_GTU = L_GTU/(1.+SCALAR12/SCALAR11)
      L_step = L_GTU/Jmax
      CALL VECTORLIB(3,'-',ISS,R,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
        cos_R_ISS  = 
     +       SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
        cos_R_ISS  = 0.
      ENDIF
      IF(ABS(cos_R_ISS).GT.1.) cos_R_ISS = 1.
      IF(ACOS(cos_R_ISS).LE.FOV) THEN
        in_fov = 1
      ENDIF
*     ... STOP TO DEVELOP SHOWER IF IT IS OUTSIDE THE FOV ...
      IF(ACOS(cos_R_ISS).GT.FOV.AND.in_fov.EQ.1) GOTO 200
      newGTU = 0
      H_R_int = 0.
      L_int   = 0. 
      d_int   = 0.
      S_int   = 0.
      Ne_int  = 0.
      NchISS_int     = 0.
      NchISSTRAN_int = 0.
      time_int    = 0.
      TRS_int     = 0.
      TMS_int     = 0.
      Nfl_int     = 0.
      NflTRAN_int = 0.
      mx_fl_int   = 0
      my_fl_int   = 0
      TR_int      = 0.
      TM_int      = 0.
      time_fl1_int = 0.
      time_fl2_int = 0.
      time_ch1_int = 0.
      time_ch2_int = 0.
      wave_fl_int  = 0.
*     ... TO AVOID PROBLEMS WITH DO_FLUORESCENCE ...
      Nfl1 = 0.
      NflTRAN = 0.
      TR = 0.
      TM = 0.
      time_fl1d = 0.
      time_fl2d = 0.
      mx_fl    = 0.
      my_fl    = 0.
      theta_xfl_int = 0.
      theta_yfl_int = 0.
      wave_fl1  = 0.
*
      DO J = 0, Jmax ! INTEGRATING OVER GTU
        L = L1 + J*L_step
*     ... DEFINE CURRENT POSITION OF THE SHOWER ...
        R(1) = RINT(1) - (L+L_step/2)*SIN(THETA)*COS(PHI)
        R(2) = RINT(2) - (L+L_step/2)*SIN(THETA)*SIN(PHI)
        R(3) = RINT(3) - (L+L_step/2)*COS(THETA)
        IF((R(1)**2+R(2)**2+R(3)**2).LE.R_EARTH**2) GOTO 100
        d    = DEPTH_R_RINT(R)
        CALL IMPACT(R,Hstar,H_INT,THETA_INT,H_R,THETA_R)
        CALL SHOWER_PARAMETRIZATION(d,Ne1,t,s)
        IF(ne1.GT.nemaxim) THEN
          nemaxim = ne1
          hmaxim  = H_R
          xmaxim  = DEPTH(R)
          yiemax  = FLUOR_YIELD(s,H_R)
        ENDIF
        IF(ACOS(cos_R_ISS).LE.FOV) THEN
          CALL DO_FLUORESCENCE(L,L_step,Ne1,S,Nfl1,NflTRAN,
     +         TR,TM,time_fl1d,time_fl2d,mx_fl,my_fl,THETA_XFL,
     +         THETA_YFL,wave_fl1)
        ENDIF
        IF(ACCEPTANCE_TYPE.EQ.1.) THEN
          CALL DO_CHERENKOV(L,Lmax,L_step,S,Ne1,NchiSS,NchISSTRAN,
     +         TRS,TMS,time_ch1d,time_ch2d)
        ENDIF
*
        THETA_XFL_INT = THETA_XFL_INT + THETA_XFL
        THETA_YFL_INT = THETA_YFL_INT + THETA_YFL
        mx_fl_int  = mx_fl_int + mx_fl
        my_fl_int  = my_fl_int + my_fl
        wave_fl_int = wave_fl_int + wave_fl1
        H_R_int = H_R_int + H_R
        L_int   = L_int + L
        d_int   = d_int + d
        S_int   = S_int + s
        Ne_int  = Ne_int + Ne1
        NchISS_int  = NchISS_int + NchISS
        NchISSTRAN_int = NchISSTRAN_int + NchISSTRAN
        IF(newGTU.EQ.0) THEN
          time_ch1_int  = time_ch1d
          time_ch2_int  = time_ch2d
          time_fl1_int  = time_fl1d 
          time_fl2_int  = time_fl2d 
          newGTU = 1
        ENDIF
        TRS_int   = TRS_int + TRS
        TMS_int   = TMS_int + TMS
        TR_int    = TR_int + TR
        TM_int    = TM_int + TM
        Nfl_int   = Nfl_int + Nfl1
        NflTRAN_int   = NflTRAN_int + NflTRAN

 100    CONTINUE
      ENDDO
      THETA_XFL = THETA_XFL_INT/J
      THETA_YFL = THETA_YFL_INT/J
      mx_fl  = mx_fl_int/J
      my_fl  = my_fl_int/J
      H_R = H_R_int/J
      L   = L_int/J
      d   = d_int/J
      S   = S_int/J
      Ne1  = Ne_int/J
      NchISS     = NchISS_int
      NchISSTRAN = NchISSTRAN_int
      time_ch1d = time_ch1_int 
      time_ch2d = time_ch2_int
      TRS    = TRS_int/J
      TMS    = TMS_int/J
*
      Nfl1      = Nfl_int
      NflTRAN   = NflTRAN_int  
      time_fl1d = time_fl1_int
      time_fl2d = time_fl2_int
      TR = TR_int/J
      TM = TM_int/J
      wave_fl1 = wave_fl_int/J
*
      IF(Nfl1.LT.THRESHOLD.AND.I.NE.0) GOTO 200 ! stop shower development at it end

      IF(Nfl1.GE.THRESHOLD) THEN
        I = I + 1
        IF(I.GE.500) GOTO 200
*     ... SHOWER INFO ...
        IF(ifps(Ne1).EQ.1)       Ne(I)     = Ne1
        IF(ifps(d).EQ.1)         depthr(I)   = d
        IF(ifps(L).EQ.1)         length(I) = L
        IF(ifps(S).EQ.1)         age(I)    = S
        IF(ifps(H_R).EQ.1)       height(I) = H_R
*     ... FLUORESCENCE INFO ...
        IF(ifps(Nfl1).EQ.1)      Nfl(I) = Nfl1
        IF(ifps(NflTRAN).EQ.1)   NflT(I)   = NflTRAN
        IF(ifps(wave_fl1).EQ.1)  wave_fl(I)  = wave_fl1
        IF(ifps(time_fl1d).EQ.1) time_fl1(I) = time_fl1d
        IF(ifps(time_fl2d).EQ.1) time_fl2(I) = time_fl2d
        IF(ifps(TR).EQ.1)        Tr_fl(I)    = TR
        IF(ifps(TM).EQ.1)        Tm_fl(I)    = TM
        IF(ifps(1.*mx_fl).EQ.1)  mxfl(I)     = mx_fl
        IF(ifps(1.*my_fl).EQ.1)  myfl(I)     = my_fl
        IF(ifps(1.*theta_xfl).EQ.1) ANGXFL(I)    = THETA_XFL
        IF(ifps(1.*theta_yfl).EQ.1) ANGYFL(I)    = THETA_YFL
 
*     ... CHERENKOV INFO ...
        IF(ifps(NchISS).EQ.1)     Nch(I)    = NchISS
        IF(ifps(NchISSTRAN).EQ.1) NchT(I)   = NchISSTRAN
        IF(I.GT.1) THEN
          IF(ifps(NchISS).EQ.1) Nchtot(I) = Nchtot(I-1) + NchISS
          IF(ifps(NchISSTRAN).EQ.1) 
     +         NchTtot(I) = NchTtot(I-1) + NchISSTRAN
        ELSE
          IF(ifps(NchISS).EQ.1)    Nchtot(I)   = NchISS
          IF(ifps(NchISSTRAN).EQ.1) NchTtot(I) = NchISSTRAN
        ENDIF
        IF(ifps(time_ch1d).EQ.1) time_ch1(I) = time_ch1d
        IF(ifps(time_ch2d).EQ.1) time_ch2(I) = time_ch2d
        IF(ifps(TRS).EQ.1) Tr_ch(I)    = TRS
        IF(ifps(TMS).EQ.1) Tm_ch(I)    = TMS
        IF(ifps(1.*mx_ch).EQ.1) mxch(I) = mx_ch
        IF(ifps(1.*my_ch).EQ.1) mych(I) = my_ch
        IF(ifps(1.*theta_xch).EQ.1) ANGXCH(I)    = THETA_XCH
        IF(ifps(1.*theta_ych).EQ.1) ANGYCH(I)    = THETA_YCH
*            
      ENDIF
      GOTO 1
 200  CONTINUE
      IF(I.GT.1.AND.I.LE.500) THEN
        NS = I
        NF = I
        NC = I
        flmax  = 0.
        fltmax = 0.
        chmax  = 0.
        chtmax = 0.
        fltot  = 0.
        flttot = 0.
        chtot  = 0.
        chttot = 0.
        DO I = 1, NS
          fltot  = fltot  + Nfl(I)
          flttot = flttot + Nflt(I)
          chtot  = chtot  + Nch(I)
          chttot = chttot + Ncht(I)
          IF(Nfl(I).GE.flmax) THEN
            iflmax  = I
            flmax  = Nfl(iflmax)
          ENDIF
          IF(Nflt(I).GE.fltmax) THEN
            ifltmax = I
            fltmax = Nflt(ifltmax)
          ENDIF
          IF(Nch(I).GE.chmax) THEN
            ichmax  = I
            chmax  = Nch(ichmax)
          ENDIF
          IF(Ncht(I).GE.chtmax) THEN
            ichtmax = I
            chtmax  = Ncht(ichtmax)
          ENDIF
        ENDDO
        
        EVENT = EVENT + 1
        CALL HFNT(NTUPLE)
        KEY_TRIG = .TRUE.
      ENDIF
 300  RETURN
      
*
      END






























