      SUBROUTINE ESAF_OUTPUT(Lmax)
#include "event.inc"
#include "shower.inc"
#include "detector.inc"
#include "random.inc"
#include "constants.inc"

*     ... EXTERNAL FUNCTIONS ...
      REAL DEPTH_R_RINT, ATM
*     ... INPUT VARIABLES    ...
      REAL Lmin, Lmax
*     ... OUTPUT VARIABLES    ...
      LOGICAL KEY_TRIG
*     ... LOCAL VARIABLES    ...
      REAL L_step, L, R(3),R1(3), RG(3), Ne1, s, d, t, time_obs_ch,L_GTU
      INTEGER LUN,Nph,N,PHTYPE
      DATA LUN/20/
      REAL RTOISS(3),SCALAR_ISS_RTOISS,SCALAR_ISS,SCALAR_RTOISS
      REAL cos_R_ISS,w,RIMPACT1,ALPHAIMPACT1,theta1c,phi1c
*     ... EXCHANGE WITH DO_CHERENKOV ...
      REAL NchISS,NchISSTRAN
      REAL TRG,TMG,TRS,TMS
      REAL TR_G,TM_G,TR_G_ISS,TM_G_ISS,time_ch1d,time_ch2d,time_ch1_int,
     +     time_ch2_int,wave_ch1
*     ... EXCHANGE WITH DO_FLUORECENCE ...
      REAL Nfl1,NflTRAN,TR,TM,time_fl1d,time_fl2d,Nfl_int,NflTRAN_int,
     +     time_fl1_int,time_fl2_int,wave_fl1
      INTEGER mx_fl,my_fl,mx_ch,my_ch,ifps
*     ... EXCHANGE WITH IMPACT ...
      REAL Hstar,H_INT,THETA_INT,H_R,THETA_R
*
      L_step   = 3.e-2          ! L_step is in km
      L_GTU    = 3.e-1*GTU      ! L_GTU is in km - length corresponding to 
                                ! one GTU
*
*     ... COORDINATES OF THE GROUND POINT ...
      RG(1) = RINT(1) - Lmax*SIN(THETA)*COS(PHI)
      RG(2) = RINT(2) - Lmax*SIN(THETA)*SIN(PHI)
      RG(3) = RINT(3) - Lmax*COS(THETA)
      CALL VECTORLIB(3,'-',ISS,RG,RTOISS)
      CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
      CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
      CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
      IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
        cos_R_ISS  = 
     +       SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
      ELSE
        cos_R_ISS  = 0.
      ENDIF  
      theta1c = ACOS(cos_R_ISS)/PI*180
      IF(RG(1).NE.0.) THEN
      phi1c   = ATAN(RG(2)/RG(1))/PI*180
      ELSE
        phi1c = 90.0
      ENDIF
*
      WRITE(LUN,*) 'BEVTBUFF EVTB'
      WRITE(LUN,*) 'BPHONUMB'
      WRITE(LUN,*) 'BXMESPHO'
      WRITE(LUN,*) 'BYMESPHO'
      WRITE(LUN,*) 'BZMESPHO'
      WRITE(LUN,*) 'BTARRPHO'
      WRITE(LUN,*) 'BWLENPHO'
      WRITE(LUN,*) 'BTHE1PHO'
      WRITE(LUN,*) 'BPHI1PHO'
      WRITE(LUN,*) 'BRADDIST'
      WRITE(LUN,*) 'BANGLPOS'
      WRITE(LUN,*) 'BPHOTYPE'
*
      Nph = 0
      DO L = 0., Lmax-L_step, L_GTU ! L      is in km
        IF(L.GT.(Lmax-L_step)) GOTO 100
        
*     ... DEFINE CURRENT POSITION OF THE SHOWER ...
        
        R(1) = RINT(1) - (L+L_step/2)*SIN(THETA)*COS(PHI)
        R(2) = RINT(2) - (L+L_step/2)*SIN(THETA)*SIN(PHI)
        R(3) = RINT(3) - (L+L_step/2)*COS(THETA)
        IF((R(1)**2+R(2)**2+R(3)**2).LE.R_EARTH**2) GOTO 100
        d    = DEPTH_R_RINT(R)
        CALL IMPACT(R,Hstar,H_INT,THETA_INT,H_R,THETA_R)
        CALL SHOWER_PARAMETRIZATION(d,Ne1,t,s)
        CALL VECTORLIB(3,'-',ISS,R,RTOISS)
        CALL VECTORDOT(3,ISS,RTOISS,SCALAR_ISS_RTOISS)
        CALL VECTORDOT(3,ISS,ISS,SCALAR_ISS)
        CALL VECTORDOT(3,RTOISS,RTOISS,SCALAR_RTOISS)
        IF(SCALAR_ISS*SCALAR_RTOISS.NE.0.) THEN
          cos_R_ISS  = 
     +         SCALAR_ISS_RTOISS/SQRT(SCALAR_ISS*SCALAR_RTOISS)
        ELSE
          cos_R_ISS  = 0.
        ENDIF            
        
*      ... FLUORESCENCE OUTPUT OF INDIVIDUAL PHOTONS ...
        
        IF(ACOS(cos_R_ISS).LE.FOV) THEN
          CALL DO_FLUORESCENCE(L,Lmax,L_step,Ne1,S,Nfl1,NflTRAN,
     +         TR,TM,time_fl1d,time_fl2d,mx_fl,my_fl,wave_fl1)
          CALL RNPSSN(NflTRAN,N,IERR)
          IF(N.EQ.0) GOTO 2
          
*     ... DEFINE END POINTS VECTORS ...
          
          R1(1) = RINT(1) - L*SIN(THETA)*COS(PHI)
          R1(2) = RINT(2) - L*SIN(THETA)*SIN(PHI)
          R1(3) = RINT(3) - L*COS(THETA)
*
*          R2(1) = RINT(1) - (L+L_step)*SIN(THETA)*COS(PHI)
*          R2(2) = RINT(2) - (L+L_step)*SIN(THETA)*SIN(PHI)
*          R2(3) = RINT(3) - (L+L_step)*COS(THETA)
*
          DO i = 1, N
            Nph = Nph + 1
*     ... GENERATE UNIFORM POINT ALONG THE TRACK L_step ... 
            CALL RANLUX(RVEC,LEN)
            X = R1(1) - L_step*SIN(THETA)*COS(PHI)*RVEC(1)
            Y = R1(2) - L_step*SIN(THETA)*SIN(PHI)*RVEC(1)
            Z = R1(3) - L_step*COS(THETA)*RVEC(1)
*     ... TRANSFORM TO MAIN EUSO SYSTEM FRAME ...
            X = X*1000             ! in m
            Y = Y*1000             ! in m
            Z = (ISS(3) - Z)*1000  !in m 
*     ... ARRIVAL TIME ...
            time_fl1d = 10./3*(L+L_step*RVEC(1)+SQRT(SCALAR_RTOISS))
            time_fl2d = time_fl1d + DEPTH_R_ISS(R)*DELTA0/ATM(0.)
*     ... PHOTON WAVELENGTH ...
            CALL FLUOR_SPECTRUM(w)
            theta1 = ACOS(cos_R_ISS)/PI*180
            IF(X.NE.0.) THEN
              phi1 = ATAN(Y/X)/PI*180
            ELSE
              phi1 = 90.0
            ENDIF
*     ... RADIAL DISTANCE OG THE PHOTON IMPACT POINT ON THE FIRST ...
*     ... FRESNEL LENS SURFACE                                    ...
            CALL SURFACE_POINT(RIMPACT1,ALPHAIMPACT1)
*     ... PHOTON TYPE ...
            PHTYPE = 1
            WRITE(LUN,200) Nph, X,Y,Z,time_fl2d,W,theta1,phi1,RIMPACT1,
     +           ALPHAIMPACT1, PHTYPE
          ENDDO
        ENDIF
        
*     ... CHERENKOV OUTPUT OF INDIVIDUAL PHOTONS ...
        
 2      CALL DO_CHERENKOV(L,Lmax,L_step,S,Ne1,NchiSS,NchISSTRAN,
     +       TRS,TMS,time_ch1d,time_ch2d)
        CALL RNPSSN(NchISSTRAN,N,IERR)
        IF(N.EQ.0) GOTO 3
        DO i = 1, N
          Nph = Nph + 1
*     ... GENERATE UNIFORM POINT ALONG THE TRACK L_step ... 
          CALL RANLUX(RVEC,LEN)
          X = R1(1) - L_step*SIN(THETA)*COS(PHI)*RVEC(1)
          Y = R1(2) - L_step*SIN(THETA)*SIN(PHI)*RVEC(1)
          Z = R1(3) - L_step*COS(THETA)*RVEC(1)
*     ... TRANSFORM TO MAIN EUSO SYSTEM FRAME ...
          X = X*1000            ! in m
          Y = Y*1000            ! in m
          Z = (ISS(3) - Z)*1000 ! in m 
*     ... ARRIVAL TIME ...
          time_ch1d =  10./3*(Lmax+L_step*RVEC(1)+SQRT(SCALAR_RTOISS))
          time_ch2d =  time_ch1d + (DEPTH(RG)-DEPTH(R))*DELTA0/ATM(0.) + 
     +         DEPTH_R_ISS(RG)*DELTA0/ATM(0.)   
*     ... PHOTON WAVELENGTH ...
          CALL CHERENKOV_SPECTRUM(w)
*     ... RADIAL DISTANCE OF THE PHOTON IMPACT POINT ON THE FIRST ...
*     ... FRESNEL LENS SURFACE                                    ...
          CALL SURFACE_POINT(RIMPACT1,ALPHAIMPACT1)
*     ... PHOTON TYPE ...
          PHTYPE = 2
          WRITE(LUN,200) Nph, X,Y,Z,time_ch2d,W,theta1c,phi1c,RIMPACT1,
     +         ALPHAIMPACT1, PHTYPE
        ENDDO
 3      CONTINUE
      ENDDO
      
 100  RETURN
 200  FORMAT(I4,1x,4(F12.3,1x),F5.1,1x,4(F12.3,1x),I1)
*
      END
      
