      SUBROUTINE FIRSTPOINT_HADRON(Lmax)
      IMPLICIT NONE
#include "event.inc"
#include "detector.inc"
#include "random.inc"
#include "constants.inc"
#include "book_histos.inc"
#include "cwntvars.inc"
 
      REAL zx,zx_width,rr_width,zmin,z_rand,r_rand,rad_fov_max
      REAL rmax,x_in_cone,y_in_cone,HXY,zz(10000),rr(10000)
      REAL H_R,THETA_R,LENGTH12,DISCR,SCALAR12,SCALAR22
      REAL theta1,theta2,thetac,EPS,a,b,c,f1,f2,fc,dir_unit(3),R2(3)
      REAL SCALAR11,z_ground,Hstar1,Hstar2, Hstar3,THETAMAX,Lmax
      REAL DEPTH_INTEGRAL,t
      INTEGER i_z_dist,zbins,i,ID,avoid_cycling,avoid_cycling_1,ID_TEST 
      INTEGER avoid_cycling_first_depth 
      SAVE i_z_dist,zbins,zmin
      DATA i_z_dist/0/,zbins/10000/,avoid_cycling_first_depth/0/
      LOGICAL TEST_FOV
      DATA TEST_FOV/.TRUE./,ID_TEST/800/
*
      IF(i_z_dist.EQ.0) THEN
        zmin = ISS(3)*SIN(FOV)**2 + COS(FOV)**2*
     +       SQRT(R_EARTH**2-TAN(FOV)**2*(ISS(3)**2-R_EARTH**2))
        rad_fov_max = (ISS(3)-zmin)*TAN(FOV)
        zx_width = 50./zbins ! 
        rr_width = rad_fov_max/zbins
        DO i = 1, zbins
          zx    = zmin + i*zx_width - zx_width/2
          zz(i) = (1.e0 - zx/ISS(3))**2
          rr(i) = i*rr_width + rr_width/2
        ENDDO
        CALL RNHPRE(zz,ZBINS)
        CALL RNHPRE(rr,ZBINS)
        IF(TEST_FOV) THEN
*     ... SIMULATED ...
          CALL HBOOK2(ID_TEST+1,'xyz in cone sim.',100,-250.,250.,
     &         100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+2,'x in cone sim.',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+3,'y in cone sim.',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+4,'z in cone sim.',100,R_EARTH,R_EARTH+50.
     &         ,0.)
          CALL HBOOK1(ID_TEST+5,'r_rand sim.',100,0.,250.,0.)
          CALL HBOOK1(ID_TEST+6,'THETA sim. ',100,0.,100.,0.)
          CALL HBOOK1(ID_TEST+7,'x1 sim.',100,0.,200.,0.)
*     ... ACCEPTED ...
          CALL HBOOK2(ID_TEST+11,'xyz in cone acc.',100,-250.,250.,
     &         100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+12,'x in cone acc.',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+13,'y in cone acc.',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+14,'z in cone acc.',100,R_EARTH,
     &         R_EARTH+50.,0.)
          CALL HBOOK1(ID_TEST+15,'r_rand acc.',100,0.,250.,0.)
          CALL HBOOK1(ID_TEST+16,'THETA acc. ',100,0.,100.,0.)
          CALL HBOOK1(ID_TEST+17,'h1 acc.',100,0.,200.,0.)
          CALL HBOOK1(ID_TEST+18,'x1 acc.',100,0.,100.,0.)
          CALL HBOOK1(ID_TEST+19,'x1',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+20,'y1',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+21,'z1',100,R_EARTH,R_EARTH+100.,0.)
          CALL HBOOK1(ID_TEST+22,'acceptance',10,0.,10.,0.)
        ENDIF
        i_z_dist = 1
      ENDIF
      CALL RNHRAN(zz,ZBINS,zmin,zx_width,z_rand)
      IF(TEST_FOV) CALL HF1(ID_TEST+4,z_rand,1.)
*     ... Maximal radius of the cone cross-section @ given z = z_rand  
      rmax = (ISS(3)-z_rand)*TAN(FOV)
 1    CALL RNHRAN(rr,ZBINS,0.,rr_width,r_rand)
c      IF(TEST_FOV) CALL HF1(ID_TEST+5,r_rand,1.)
*     ... reject events below the EARTH ...
      IF(SQRT(z_rand**2+r_rand**2).LT.R_EARTH) GOTO 1
      IF(r_rand.GT.rmax) GOTO 1
      IF(TEST_FOV) CALL HF1(ID_TEST+5,r_rand,1.)
      avoid_cycling = 0
 2    CALL RANLUX(RVEC,LEN)
      PHI = PHIR(1) + (PHIR(2)-PHIR(1))*RVEC(3)
      x_in_cone = r_rand*COS(PHI/180.*PI)
      y_in_cone = r_rand*SIN(PHI/180.*PI)
*     ... REDEFINE PHI TO AVOID POINTG TO THE CENTER
      PHI = PHIR(1) + (PHIR(2)-PHIR(1))*RVEC(88)
      H_R = SQRT(r_rand**2+z_rand**2) - R_EARTH
      IF(TEST_FOV) CALL HFILL(ID_TEST+1,x_in_cone,y_in_cone,z_rand)
      IF(TEST_FOV) CALL HF1(ID_TEST+2,x_in_cone,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+3,y_in_cone,1.)
*     ... UNIFORM RANDOM THETA  ...
      THETAMAX = PI - ASIN(R_EARTH/(R_EARTH+H_R))
c      write(6,*) THETAMAX/PI*180
      THETAMAX = MIN(THETAMAX,THETAR(2)/180.*PI)
      THETA_R = THETAR(1)/180*PI + RVEC(33)*(THETAMAX-THETAR(1)/180*PI) ! in rad.
c      write(6,*) THETA_R/PI*180
      IF(TEST_FOV) CALL HF1(ID_TEST+6,THETA_R,1.)
*     ... RANDOM FIRST INTERACTION DEPTH ...
      CALL First_Depth_Hadron
      IF(TEST_FOV) CALL HF1(ID_TEST+7,x1,1.)
*     ... FIND HEIGHT CORRESPONDING TO GIVEN THETA AND X1
      ID = 100*ATMO
*     ... FIND A MINIMAL HEIGHT FOR A GIVEN THETA AND H_R
      a = 0.
      b = 200.
      IF(theta_r.LE.PI/2) THEN
        f1 = HXY(ID+CURV,theta_r,a) - X1
        f2 = HXY(ID+CURV,theta_r,b) - X1
c        f1 = DEPTH_INTEGRAL(THETA_R,A) - X1
c        f2 = DEPTH_INTEGRAL(THETA_R,B) - X1
      ELSE
        Hstar1 = (R_EARTH+a)*SIN(THETA_R) - R_EARTH
        IF(Hstar1.LT.0.) Hstar1 = 0.
        Hstar2 = (R_EARTH+b)*SIN(THETA_R) - R_EARTH
        f1 = 2*HXY(ID+CURV,PI/2,Hstar1) - HXY(ID+CURV,theta_r,a) - X1
        f2 = 2*HXY(ID+CURV,PI/2,Hstar2) - HXY(ID+CURV,theta_r,b) - X1
c        f1 = 2*DEPTH_INTEGRAL(PI/2,Hstar1)-DEPTH_INTEGRAL(THETA_R,A)-X1
c        f2 = 2*DEPTH_INTEGRAL(PI/2,Hstar2)-DEPTH_INTEGRAL(THETA_R,B)-X1
c        WRITE(6,*) theta_r, f1,f2,X1
      ENDIF
*
      IF(f1*f2.GT.0.) THEN
        WRITE(6,*) '*** Warning from firtspoint.F              ***'
        WRITE(6,*) '*** Could not find proper height for x1, theta:'
c        WRITE(6,*) x1, theta_r,HXY(ID+CURV,PI/2,Hstar1),
c     +       HXY(ID+CURV,PI/2,Hstar2),Hstar1,Hstar2
        WRITE(6,*) x1, theta_r,Hstar1,Hstar2,f1,f2
        WRITE(6,*) A,B, DEPTH_INTEGRAL(THETA_R,A),  
     &       DEPTH_INTEGRAL(THETA_R,B)
        WRITE(6,*) '*** Trying again ...                       ***'
        avoid_cycling = avoid_cycling + 1
        IF(avoid_cycling.GT.100) THEN
          WRITE(6,*) '*** Error from firtspoint.F              ***'
          WRITE(6,*) '*** Number of trials reached its limit.  ***'
          WRITE(6,*) '*** STOP                                 ***'
          STOP
        ENDIF
        GOTO 2
      ENDIF
      fc = 100.
      EPS = 1.e-1
      avoid_cycling_1 = 0 
 3    IF(ABS(fc).LE.EPS) GOTO 4
      c = (a+b)/2
      theta1 = ASIN((R_EARTH+H_R)*SIN(THETA_R)/(R_EARTH+a))
      theta2 = ASIN((R_EARTH+H_R)*SIN(THETA_R)/(R_EARTH+b))
      thetac = ASIN((R_EARTH+H_R)*SIN(THETA_R)/(R_EARTH+c))
      IF(theta_r.LE.PI/2) THEN
        f1 = HXY(ID+CURV,theta1,a) - X1
        f2 = HXY(ID+CURV,theta2,b) - X1      
        fc = HXY(ID+CURV,thetac,c) - X1
c        f1 = DEPTH_INTEGRAL(THETA1,A)-X1
c        f2 = DEPTH_INTEGRAL(THETA2,B)-X1
c        fc = DEPTH_INTEGRAL(THETAC,C)-X1
      ELSE
        Hstar1 = (R_EARTH+a)*SIN(THETA1) - R_EARTH
        Hstar2 = (R_EARTH+b)*SIN(THETA2) - R_EARTH
        Hstar3 = (R_EARTH+c)*SIN(THETAC) - R_EARTH
        f1 = 2*HXY(ID+CURV,PI/2,Hstar1) - HXY(ID+CURV,theta1,a) - X1
        f2 = 2*HXY(ID+CURV,PI/2,Hstar2) - HXY(ID+CURV,theta2,b) - X1      
        fc = 2*HXY(ID+CURV,PI/2,Hstar3) - HXY(ID+CURV,thetac,c) - X1
c        f1 = 2*DEPTH_INTEGRAL(PI/2,Hstar1)-DEPTH_INTEGRAL(THETA1,A)-X1
c        f2 = 2*DEPTH_INTEGRAL(PI/2,Hstar2)-DEPTH_INTEGRAL(THETA2,B)-X1
c        fc = 2*DEPTH_INTEGRAL(PI/2,Hstar3)-DEPTH_INTEGRAL(THETAC,C)-X1
      ENDIF        
      avoid_cycling_1 = avoid_cycling_1 + 1
      IF(avoid_cycling_1.GT.20) THEN
*     ... give a last chance ...       
        IF(ABS(fc).LE.10*EPS) GOTO 4
        GOTO 2
      ENDIF

      IF(fc*f1.LE.0.) THEN
        b = c
        GOTO 3
      ELSEIF(fc*f2.LE.0.) THEN
        a = c
        GOTO 3
      ENDIF
 4    CONTINUE
      H_R = c
      THETA = THETA_R/PI*180
      avoid_cycling = 0
      avoid_cycling_1 = 0
*     ... FIND RADIUS VECTOR OF THE FIRST POINT ...
      dir_unit(1) = SIN(THETA/180*PI)*COS(PHI/180.*PI)
      dir_unit(2) = SIN(THETA/180*PI)*SIN(PHI/180.*PI)
      dir_unit(3) = COS(THETA/180*PI)
      R2(1) = x_in_cone
      R2(2) = y_in_cone
      R2(3) = z_rand
      CALL VECTORDOT(3,dir_unit,R2,SCALAR12)
      CALL VECTORDOT(3,R2,R2,SCALAR22)
      DISCR = SCALAR12**2 - SCALAR22 + (R_EARTH+H_R)**2
      IF(DISCR.LT.0.) GOTO 2
      DISCR = SQRT(DISCR)
      LENGTH12 = - SCALAR12 + DISCR
      RINT(1) = R2(1) + LENGTH12*SIN(THETA/180*PI)*COS(PHI/180.*PI)
      RINT(2) = R2(2) + LENGTH12*SIN(THETA/180*PI)*SIN(PHI/180.*PI)
      RINT(3) = R2(3) + LENGTH12*COS(THETA/180*PI) 
*     ...  THETA,PHI ARE RETURNED IN DEGREES ...
      CALL ACCEPTANCE(Lmax,ACCEPTANCE_TYPE)
      IF(TEST_FOV) CALL HFILL(ID_TEST+11,x_in_cone,y_in_cone,z_rand)
      IF(TEST_FOV) CALL HF1(ID_TEST+12,x_in_cone,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+13,y_in_cone,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+14,z_rand,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+15,r_rand,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+16,THETA,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+17,H_R,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+18,x1,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+19,RINT(1),1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+20,RINT(2),1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+21,RINT(3),1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+22,ACCEPTANCE_TYPE,1.)
      RINT(3) = RINT(3) - R_EARTH
*
      CALL TIMED(t)
      WRITE(6,*) 'time=', t      
      END

