      SUBROUTINE FIRSTPOINT_NEUTRINO(Lmax)
      IMPLICIT NONE
#include "detector.inc"
#include "event.inc"
#include "random.inc"
      INTEGER ifirst,i,i_step,ID_TEST
      LOGICAL TEST_FOV
      DATA ifirst/0/,TEST_FOV/.TRUE./
      SAVE ifirst,BETA
      REAL Zmin,R,BETA,BETAR,h,PI,h_step,h_r,rho(10000)
      REAL ATM,THETAMAX,Lmax,hmin,COSBETAMIN
      REAL depth
*
      IF(ifirst.EQ.0) THEN
        Zmin = ISS(3)*SIN(FOV)**2+
     +       COS(FOV)*SQRT(R_EARTH**2-ISS(3)**2*SIN(FOV)**2)
        R = SQRT(R_EARTH**2-Zmin**2)
        BETA = R/R_EARTH        ! SIN(BETA)
        COSBETAMIN = SQRT(1.-BETA**2)
        h_step = 0.01
        hmin = 0.
        h = - h_step
        PI = ACOS(-1.)
        i_step = 5000
        DO i = 1, i_step
          h = h + h_step
          rho(i) = ATM(h)
        ENDDO
        CALL RNHPRE(rho,i_step)
        IF(TEST_FOV) THEN
          ID_TEST = 900
          CALL HBOOK1(ID_TEST+1,'height',100,0.,50.,0.)
          CALL HBOOK1(ID_TEST+2,'x',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+3,'y',100,-250.,250.,0.)
          CALL HBOOK1(ID_TEST+4,'z',100,R_EARTH,R_EARTH+50.
     &         ,0.)
          CALL HBOOK1(ID_TEST+5,'BETA',100,0.,0.05,0.)
          CALL HBOOK1(ID_TEST+6,'PHI LOCAL',100,0.,360.,0.)
          CALL HBOOK1(ID_TEST+7,'THETA',100,0.,110.,0.)
          CALL HBOOK1(ID_TEST+8,'PHI ',100,0.,360.,0.)
          CALL HBOOK1(ID_TEST+9,'acceptance',10,0.,10.,0.)
        ENDIF
        ifirst = 1
      ENDIF
*     ... GENERATE RANDOM LOCAL HEIGHT ACCORDING TO THE AIR DENSITY
      CALL RNHRAN(rho,i_step,hmin,h_step,h_r)
*     ... GENERATE RANDOM SIN(BETA) - BETA IS THE ANGLE FROM EARTH
*     ... CENTER, AND PHI - ASIMUTAL ANGLE
      CALL RANLUX(RVEC,LEN)
      PHI = PHIR(1) + (PHIR(2)-PHIR(1))*RVEC(3)
      IF(TEST_FOV) CALL HF1(ID_TEST+6,PHI,1.)
      BETAR = SQRT(1.-(1.-(1.-COSBETAMIN)*RVEC(48))**2)
*     ... THE FIRST INTERACTION POINT ...
      RINT(1) = (R_EARTH+H_R)*BETAR*COS(PHI/180*PI)
      RINT(2) = (R_EARTH+H_R)*BETAR*SIN(PHI/180*PI)
      RINT(3) = (R_EARTH+H_R)*SQRT(1.-BETAR**2)
*     ... GENERATE RANDOM DIRECTION ...
      PHI = PHIR(1) + (PHIR(2)-PHIR(1))*RVEC(33)
      THETAMAX = PI - ASIN(R_EARTH/(R_EARTH+H_R))
      THETAMAX = MIN(THETAMAX,THETAR(2)/180.*PI)
      THETA = THETAR(1) + RVEC(35)*(THETAMAX/pi*180-THETAR(1)) ! in deg.
*     ... COMPUTE X1 ...
      THETA = THETA/180*PI
      PHI   = PHI/180*PI
      X1 = DEPTH(RINT)
      THETA = THETA/PI*180
      PHI   = PHI/PI*180
*     ... SAVE INFO FOR LATER CHECKING ...
      IF(TEST_FOV) CALL HF1(ID_TEST+1,H_R,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+2,RINT(1),1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+3,RINT(2),1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+4,RINT(3),1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+5,BETAR,1.)

      IF(TEST_FOV) CALL HF1(ID_TEST+7,THETA,1.)
      IF(TEST_FOV) CALL HF1(ID_TEST+8,PHI,1.)
*     ...  THETA,PHI ARE RETURNED IN DEGREES ...
      CALL ACCEPTANCE(Lmax,ACCEPTANCE_TYPE)
      IF(TEST_FOV) CALL HF1(ID_TEST+9,ACCEPTANCE_TYPE,1.)
      RINT(3) = RINT(3) - R_EARTH
*
      END
