*     ... THIS IS AN ANALITICAL PARAMETRIZATION OF THE  ...
*     ... QGSJET MODEL ADOPTED IN CORSIKA PACKAGE       ...
*     ... THIS PARAMETRIZATION IS KNOWN AS GIL FORMULA  ...
*     ... INPUT:  x (depth in g/cm^2)                   ...
*     ... OUTPUT: Ne - number of electrons              ...
*     ...         t  - depth in radiation length        ...
*     ...         s  - shower age                       ...
*     ... DATE: 03.06.2002                              ...
*     ... AUTHOR: D.V.NAUMOV                            ...
      SUBROUTINE QGSJET(x,Ne,t,s)
      IMPLICIT NONE
#include "event.inc"
      REAL x,Ne,t,s,A
      REAL t0, t_max
*
      Ne  = 0.
      t0  = 37.15               ! g/cm^2 radiation length in air
      t   = x/t0                ! depth in the radiation length
      A = TYPER
      IF(TYPER.LT.1.OR.TYPER.GT.1000) A = 1
      t_max = 1.7 + 0.76*(LOG(EINT/0.81e8) - LOG(1.e0*A))
      s   = 2*t/(t+t_max)
      
      IF(s.LE.0.) RETURN
      IF(s.GT.0.) Ne  = EINT/1.45e9*EXP(t-t_max-2*t*LOG(s)) 
      END
