      SUBROUTINE SIMULATION
      IMPLICIT NONE
#include "event.inc"
#include "cwntvars.inc"
#include "random.inc"
#include "detector.inc"
#include "constants.inc"

      REAL DEPTH
      REAL v1,v2,rad_unit,rad_fov,rad_fov_max,S,C,Lmax,Lmin,L
      REAL C1,C2,S1,S2
      REAL d,EY(1000),Ewidth,ex,RG(3),zmin,THETAMAX
      INTEGER N,i,Ebins,i_eint_init,i_rad_fov_max,iss_first
      SAVE i_eint_init,i_rad_fov_max
      SAVE iss_first
      DATA i_eint_init/0/,i_rad_fov_max/0/
      DATA iss_first/0/
*
      IF(NEVT.LT.1) RETURN
      PI  = ACOS(-1.)
      IF(iss_first.EQ.0) THEN
         ISS(3) = ISS(3) + R_EARTH   ! TRANSFORM TO SPHERICAL COORDINATES
         FOV   = FOV/180.*PI
         iss_first = 1
      ENDIF
*    
      IF(.NOT.(EINTR(2).EQ.EINTR(1))) THEN
        Ebins  =  1000
        Ewidth =  (EINTR(2) - EINTR(1))/Ebins
        IF(i_eint_init.EQ.0) THEN
          DO i = 1, Ebins
            ex    = EINTR(1) + i*Ewidth - Ewidth/2
            ey(i) = REAL(1.d50/DBLE(ex)**DBLE(POWER))
          ENDDO
          CALL RNHPRE(EY,EBINS)
          i_eint_init = 1
        ENDIF
      ENDIF
*
      EVENT = 0
      EINT  = EINTR(1)
      THETA = THETAR(1)
      PHI   = PHIR(1)
      IF((EINTR(1).EQ.EINTR(2)   .AND.
     +     THETAR(1).EQ.THETAR(2).AND.
     +     PHIR(1).EQ.PHIR(2)).OR.NEVT.EQ.1)   THEN
        EINTW   = 1.
        RINT(3) = RINT(3) + R_EARTH
        CALL ACCEPTANCE(Lmax)
        RINT(3) = RINT(3) - R_EARTH
        CALL TRANSFORM_COORDINATES('FORWARD')
        CALL GENERATE_EVENT(Lmax)
        GOTO 2
      ENDIF
*
      CALL RANLUX(RVEC,LEN)
*     ... DEFINE ENERGY,THETA,PHI ...
      IF(.NOT.(EINTR(2).EQ.EINTR(1))) THEN
        CALL RNHRAN(EY,EBINS,EINTR(1),Ewidth,EINTW) 
      ENDIF
      EINT    = EINTR(1) + (EINTR(2) - EINTR(1))*RVEC(44)
      EINTW   = (EINT/EINTR(1))**(-POWER)
      CALL FIRSTPOINT(Lmax)
      CALL TRANSFORM_COORDINATES('FORWARD')
      CALL GENERATE_EVENT(Lmax)
 2    RETURN
      END
